#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

#ifdef ONPC
    mt19937 rnd(228);
#else
    mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 3e5 + 7;

struct fenw
{

    int t[N];

    void inc(int x, int y)
    {
        for (; x >= 0; x = (x & (x + 1)) - 1)
        {
            t[x] += y;
        }
    }

    int get(int x)
    {
        int ans = 0;
        for (; x < N; x = (x | (x + 1)))
        {
            ans += t[x];
        }
        return ans;
    }

    void init()
    {
        for (int i = 0; i < N; i++)
        {
            t[i] = 0;
        }
    }
};

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    fenw q_values, p_values;
    q_values.init(), p_values.init();
    int n;
    ll k;
    cin >> n >> k;
    vector <int> p(n), q(n);
    for (int i = 0; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
    }
    for (int i = 0; i < n; i++)
    {
        cin >> q[i];
        q[i]--;
    }
    vector <int> ptr(n);
    for (int i = 0; i < n; i++)
    {
        ptr[i] = n;
    }
    int x = n;
    ll cur_grab = n * (ll) (n - 1) / 2;
    for (int i = 0; i < n; i++)
    {
        q_values.inc(i, 1);
        p_values.inc(i, 1);
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = x - 1; j >= 0; j--)
        {
            int pupa = ((n - i) - p_values.get(q[j]));
            /*
            for (int go = i; go < n; go++)
            {
                if (q[j] > p[go])
                {
                    pupa++;
                }
            }
            */
            if (cur_grab - pupa >= k)
            {
                q_values.inc(q[j], -1);
                x = j;
                cur_grab -= pupa;
            }
            else
            {
                break;
            }
        }
        ptr[i] = x;
        k -= q_values.get(p[i] + 1);
        cur_grab -= q_values.get(p[i] + 1);
        p_values.inc(p[i], -1);
    }
    assert(k == 0);
    cout << "Yes\n";
    vector <int> go(n, -n);
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++)
    {
        a[p[i]] = -ptr[i];
        if (ptr[i] != n)
        {
            go[ptr[i]] = max(go[ptr[i]], ptr[i]);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (i)
        {
            go[i] = max(go[i], go[i - 1]);
        }
        b[q[i]] = go[i];
    }
    for (int i = 0; i < n; i++)
    {
        cout << a[i] << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; i++)
    {
        cout << b[i] << ' ';
    }
    cout << '\n';
}
