#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
mt19937 rnd;
const int MOD = 998244353;

void add(int &x, ll y) {
  x = (x + y) % MOD;
}

int mul(int a, int b) {
  return (ll)a * b % MOD;
}

int bin(int a, int n) {
  int res = 1;
  while (n) {
    if (n & 1) res = mul(res, a);
    a = mul(a, a);
    n >>= 1;
  }
  return res;
}

int inv(int x) {
  return bin(x, MOD - 2);
}

vector<int> berlekamp(vector<int> a) {
  vector<int> p({1}), r({1});
  int dif = 1;
  for (int i = 0; i < (int)a.size(); i++) {
    int u = 0;
    for (int j = 0; j < (int)p.size(); j++) {
      u = (u + mul(p[j], a[i - j])) % MOD;
    }
    if (u == 0) {
      r.insert(r.begin(), 0);
    } else {
      auto op = p;
      p.resize(max(p.size(), r.size() + 1));
      int idif = inv(dif);
      for (int j = 0; j < (int)r.size(); j++) {
        p[j + 1] = (p[j + 1] - mul(r[j], mul(idif, u)) + MOD) % MOD;
      }
      dif = u;
      r = op;
    }
  }
  return p;
}

vector<int> annul(int n, vector<pair<pair<int, int>, int>> ed) {
  vector<int> u(n), v(n);
  for (int i = 0; i < n; i++) {
    u[i] = rnd() % MOD;
    v[i] = rnd() % MOD;
  }
  vector<int> vals;
  int iters = n * 2 + 5;
  while (iters--) {
    int cur = 0;
    for (int i = 0; i < n; i++) add(cur, mul(u[i], v[i]));
    vals.push_back(cur);
    vector<int> nu(n);
    for (auto o : ed) {
      add(nu[o.first.second], mul(u[o.first.first], o.second));
    }
    u = nu;
  }
  return berlekamp(vals);
}

int solve(int n, vector<pair<int, int>> ed) {
  vector<int> deg(n);
  for (auto o : ed) {
    deg[o.first]++;
    deg[o.second]++;
  }
  n--;
  for (int i = 0; i < n; i++) deg[i] = inv(deg[i]);

  vector<pair<pair<int, int>, int>> vct;
  for (auto o : ed) {
    if (o.first < n && o.second < n) {
      vct.push_back({{o.first, o.second}, (MOD - deg[o.first]) % MOD});
      vct.push_back({{o.second, o.first}, (MOD - deg[o.second]) % MOD});
    }
  }
  for (int i = 0; i < n; i++) vct.push_back({{i, i}, 1});

  auto p = annul(n, vct);
  reverse(p.begin(), p.end());

  int ans = 0;
  vector<int> pr(n);
  pr[0] = 1;
  for (int i = 1; i < (int)p.size(); i++) {
    int cur = 0;
    for (int j = 0; j < n; j++) add(cur, pr[j]);
    add(ans, mul(cur, p[i]));
    
    vector<int> npr(n);
    for (auto o : vct) {
      add(npr[o.first.second], mul(pr[o.first.first], o.second));
    }
    pr = npr;
  }
  ans = mul(MOD - ans, inv(p[0]));

  return ans;
}

int main() {
  int n;
  scanf("%d", &n);
  for (int i = 0; i < n; i++) {
    int x, y;
    scanf("%d%d", &x, &y);
  }
  int m;
  scanf("%d", &m);
  vector<pair<int, int>> ed(m);
  for (int i = 0; i < m; i++) {
    scanf("%d%d", &ed[i].first, &ed[i].second);
    ed[i].first--;
    ed[i].second--;
  }
  
  printf("%d\n", solve(n, ed));
}
